/*  Arduino MOTEUR DC Control - PWM  | 
 *  L293 
 *  SERVOMOTEUR
 *  TELECOMMANDE IR
*/
#include <Servo.h>
#include <IRremote.h>

int RECV_PIN =  2;        //CAPTEUR IR
IRrecv irrecv(RECV_PIN);
decode_results results;

int enA = 3 ; //  MOTEURS
int in1 = 4 ; //
int in2 = 5 ; //
int enB = 6 ; //
int in3 = 7 ;  //
int in4 = 8 ; //
int motorSpeedA = 255;  //PWM motor A
int motorSpeedB = 255;  //PWM motor B

Servo monServo ;  //declare  utilisation d un servo nommé "monServo"
int positionDuservo = 0 ;  //variable contenant la position souhaitée du servo

void setup()
{
  
  pinMode(enA, OUTPUT);
  pinMode(enB, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);

   monServo.attach(9);  //servo pin 9
  monServo.write(positionDuservo) ;
  
  Serial.begin(9600);
   irrecv.enableIRIn();
}
void loop() {
 
    Serial.println(results.value,HEX);
   if(irrecv.decode(&results))
  {
 
    if (results.value==0xA32AB931)       //arriere
    {                             
    // Set Motor A backward
    digitalWrite(in1, LOW);
    digitalWrite(in2,  HIGH);
    // Set Motor B backward
    digitalWrite(in3, LOW);
    digitalWrite(in4,  HIGH);
     delay(300); 
   
  
   Serial.println(results.value,HEX);
  }
   else if (results.value == 0x371A3C86)      //avant
   {                                
    // Set Motor A forward
    digitalWrite(in1,  HIGH);
    digitalWrite(in2, LOW);
    // Set Motor B forward
    digitalWrite(in3,  HIGH);
    digitalWrite(in4, LOW);
     delay(300); 
  }

   else if (results.value == 0x39D41DC6)    // gauche 
   {                  
 
    // Set Motor A backward
    digitalWrite(in1, LOW);
    digitalWrite(in2, HIGH);
    // Set Motor B forward
    digitalWrite(in3, HIGH );
    digitalWrite(in4, LOW);
     delay(50);   
    }
  else if (results.value == 0x143226DB)     //droite 
  {                       
   
    // Set Motor A forward
    digitalWrite(in1, HIGH);
    digitalWrite(in2, LOW);
    // Set Motor B backward
    digitalWrite(in3, LOW );
    digitalWrite(in4, HIGH);
    delay(50);                    //
   }
    else if (results.value==0xE0984BB6)
   {                              //
  positionDuservo = 180;// positionDuservo <=180; positionDuservo++ ;//for
  //{
  monServo.write(positionDuservo);
  delay(600) ;  
  }
    irrecv.resume();

}

 else

{
  positionDuservo =0 ;// positionDuservo >=0; positionDuservo--) //for
//{
  monServo.write(positionDuservo);
  delay(50) ;
 
 // Set Motor A 
digitalWrite(in1, LOW);
digitalWrite(in2, LOW);
 // Set Motor B 
digitalWrite(in3,LOW);
digitalWrite(in4, LOW);
}
  
  analogWrite(enA, motorSpeedA); // Send PWM signal to motor A
  analogWrite(enB, motorSpeedB); // Send PWM signal to motor B
  }


